﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace wpf_Chart_668988
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            var barSeries = this.chart1.Series[0] as Telerik.Windows.Controls.ChartView.BarSeries;
            barSeries.CategoryBinding = new Telerik.Windows.Controls.ChartView.GenericDataPointBinding<TimelineChartPoint, string>() { ValueSelector = item => "The Category Here" };
            barSeries.ValueBinding = new Telerik.Windows.Controls.ChartView.GenericDataPointBinding<TimelineChartPoint, double>() { ValueSelector = item => item.Duration };
            var data = new List<TimelineChartPoint>() 
            {
                new TimelineChartPoint { Stopped = true, Duration = 2 },
                new TimelineChartPoint { Stopped = false, Duration = 3 },
                new TimelineChartPoint { Stopped = true, Duration = 1 },
                new TimelineChartPoint { Stopped = false, Duration = 4 },
                new TimelineChartPoint { Stopped = true, Duration = 1 },
            };
            barSeries.ItemsSource = data;

            this.SetupChart2(data);
        }

        private void SetupChart2(List<TimelineChartPoint> data)
        {
            this.chart2.DefaultView.ChartArea.Legend.Visibility = Visibility.Collapsed;
            this.chart2.DefaultView.ChartArea.AxisX.StripLinesVisibility = System.Windows.Visibility.Collapsed;
            this.chart2.DefaultView.ChartArea.AxisY.StripLinesVisibility = System.Windows.Visibility.Collapsed;
            var ds = new Telerik.Windows.Controls.Charting.DataSeries();
            ds.Definition = new Telerik.Windows.Controls.Charting.HorizontalRangeBarSeriesDefinition() { ItemStyle = this.Resources["BarStyle"] as Style };

            int sum = 0;
            foreach (var item in data)
            {
                Telerik.Windows.Controls.Charting.DataPoint dp = new Telerik.Windows.Controls.Charting.DataPoint()
                {
                    XCategory = "category 1",
                    Low = sum,
                    High = sum + item.Duration,
                    DataItem = item,
                };
                sum = sum + item.Duration;
                ds.Add(dp);
            }

            this.chart2.DefaultView.ChartArea.DataSeries.Add(ds);
        }
    }

    public class TimelineChartPoint
    {
        bool stopped;

        public bool Stopped
        {
            get { return stopped; }
            set { stopped = value; }
        }

        int duration; //seconds

        public int Duration
        {
            get { return duration; }
            set { duration = value; }
        }

        public Brush Brush { get { return new SolidColorBrush(this.stopped ? Colors.Red : Colors.White); } }
    }
}
